//
// generated by Qedo
//

#include "dinner_ObserverImpl.h"


// BEGIN USER INSERT SECTION file
#include <iostream>
#include "Output.h"

using namespace std;
// END USER INSERT SECTION file


namespace dinner {


// BEGIN USER INSERT SECTION ObserverSessionImpl
// END USER INSERT SECTION ObserverSessionImpl


ObserverSessionImpl::ObserverSessionImpl()
{
// BEGIN USER INSERT SECTION ObserverSessionImpl::ObserverSessionImpl
// END USER INSERT SECTION ObserverSessionImpl::ObserverSessionImpl
}


ObserverSessionImpl::~ObserverSessionImpl()
{
// BEGIN USER INSERT SECTION ObserverSessionImpl::~ObserverSessionImpl
	cout << "ObserverSessionImpl: Destructor called" << endl;
// END USER INSERT SECTION ObserverSessionImpl::~ObserverSessionImpl

}


void
ObserverSessionImpl::set_context(::dinner::CCM_Observer_ContextImpl_ptr context)
    throw (CORBA::SystemException, Components::CCMException)
{
    context_ = ::dinner::CCM_Observer_ContextImpl::_duplicate(context);
}


void
ObserverSessionImpl::configuration_complete()
    throw (CORBA::SystemException, Components::InvalidConfiguration)
{
// BEGIN USER INSERT SECTION ObserverSessionImpl::configuration_complete
	CORBA::Object_ptr obj = context_->resolve_service_reference("ConfigurationService");
	ConfigurationService::InternalConfiguration_var cfg;
	cfg = ConfigurationService::InternalConfiguration::_narrow(obj);
	char* s = cfg->get_value("INSTALLATION_DIR");
	std::cerr << "########## observer install dir is " << s << std::endl;
	/*
#ifdef _WIN32
	std::string exe = s;
	exe.append("\\");
	exe.append("notepad.exe");
	std::cerr << "########## executing " << exe << std::endl;
	int component_server_pid = _spawnl(_P_NOWAIT, exe.c_str(), exe.c_str(), NULL);
#endif
	*/
	delete s;
// END USER INSERT SECTION ObserverSessionImpl::configuration_complete
}


void
ObserverSessionImpl::remove()
    throw (CORBA::SystemException)
{
// BEGIN USER INSERT SECTION ObserverSessionImpl::remove
// END USER INSERT SECTION ObserverSessionImpl::remove
}


void
ObserverSessionImpl::push_event (Components::EventBase* ev)
    throw (CORBA::SystemException)
{
// BEGIN USER INSERT SECTION ObserverSessionImpl::push_event
	dinner::PhilosopherState* e = dinner::PhilosopherState::_downcast (ev);
	

	if (!e) 
	{
		// handle error
    }

    this->push_PhilosopherState (e);
// END USER INSERT SECTION ObserverSessionImpl::push_event
}


void
ObserverSessionImpl::push_PhilosopherState(::dinner::PhilosopherState* ev)
    throw (CORBA::SystemException)
{
// BEGIN USER INSERT SECTION ObserverSessionImpl::push_PhilosopherState
	cout << "ObserverSessionImpl: EVENT: Philosoph " << ev->name() << " is ";

	switch (ev->status())
	{
	case dinner::THINKING:
		cout << "thinking";
		break;
	case dinner::HUNGRY:
		cout << "hungry";
		break;
	case dinner::EATING:
		cout << "eating";
		break;
	case dinner::SLEEPING:
		cout << "sleeping";
		break;
	case dinner::DEAD:
		cout << "dead" << endl;
		break;
	}

	cout << endl;
// END USER INSERT SECTION ObserverSessionImpl::push_PhilosopherState
}


// BEGIN USER INSERT SECTION ObserverImpl
// END USER INSERT SECTION ObserverImpl


ObserverImpl::ObserverImpl()
:component_(new ObserverSessionImpl())
{
// BEGIN USER INSERT SECTION ObserverImpl::ObserverImpl
// END USER INSERT SECTION ObserverImpl::ObserverImpl
}


ObserverImpl::~ObserverImpl()
{
// BEGIN USER INSERT SECTION ObserverImpl::~ObserverImpl
	cout << "ObserverImpl: Destructor called" << endl;
// END USER INSERT SECTION ObserverImpl::~ObserverImpl

    component_->_remove_ref();
}


::CORBA::Object*
ObserverImpl::obtain_executor(const char* name)
    throw (CORBA::SystemException)
{
    if (! strcmp ( name, "component" ) ) {
        return Components::EnterpriseComponent::_duplicate (component_);
    }
    
    return Components::EnterpriseComponent::_nil();
}


void
ObserverImpl::release_executor(::CORBA::Object_ptr executor)
    throw (CORBA::SystemException)
{
    CORBA::release (executor);
}


void
ObserverImpl::configuration_complete()
    throw (CORBA::SystemException, Components::InvalidConfiguration)
{
    component_->configuration_complete();

// BEGIN USER INSERT SECTION ObserverImpl::configuration_complete
// END USER INSERT SECTION ObserverImpl::configuration_complete
}


void
ObserverImpl::set_session_context(::Components::SessionContext_ptr context)
    throw (CORBA::SystemException, Components::CCMException)
{
    #ifdef TAO_ORB
    ::dinner::CCM_Observer_Context_ptr tmp_context;
    
    tmp_context = dynamic_cast<::dinner::CCM_Observer_ContextImpl*>(context);
    
    if (tmp_context)
        context_ = ::dinner::CCM_Observer_ContextImpl::_duplicate(tmp_context);
    else
        context_ = ::dinner::CCM_Observer_ContextImpl::_nil();
        
    #else
    context_ = ::dinner::CCM_Observer_ContextImpl::_narrow(context);
    
    #endif
    component_->set_context(context_);
}


void
ObserverImpl::ccm_activate()
    throw (CORBA::SystemException, Components::CCMException)
{
// BEGIN USER INSERT SECTION ObserverImpl::ccm_activate
	cout << "ObserverImpl: ccm_activate() called" << endl;
// END USER INSERT SECTION ObserverImpl::ccm_activate
}


void
ObserverImpl::ccm_passivate()
    throw (CORBA::SystemException, Components::CCMException)
{
// BEGIN USER INSERT SECTION ObserverImpl::ccm_passivate
	cout << "ObserverImpl: ccm_passivate() called" << endl;
// END USER INSERT SECTION ObserverImpl::ccm_passivate
}


void
ObserverImpl::ccm_remove()
    throw (CORBA::SystemException, Components::CCMException)
{
// BEGIN USER INSERT SECTION ObserverImpl::ccm_remove
	cout << "ObserverImpl: ccm_remove() called" << endl;
// END USER INSERT SECTION ObserverImpl::ccm_remove
}


// BEGIN USER INSERT SECTION ObserverHomeImpl
// END USER INSERT SECTION ObserverHomeImpl


ObserverHomeImpl::ObserverHomeImpl()
{
// BEGIN USER INSERT SECTION ObserverHomeImpl::ObserverHomeImpl
// END USER INSERT SECTION ObserverHomeImpl::ObserverHomeImpl
}


ObserverHomeImpl::~ObserverHomeImpl()
{
// BEGIN USER INSERT SECTION ObserverHomeImpl::~ObserverHomeImpl
	cout << "ObserverHomeImpl: Destructor called" << endl;

	int dummy = 0;
	CORBA::ORB_var orb = CORBA::ORB_init (dummy, 0);

	orb->unregister_value_factory ("IDL:dinner/PhilosopherState:1.0");
// END USER INSERT SECTION ObserverHomeImpl::~ObserverHomeImpl

}


void
ObserverHomeImpl::set_context(Components::HomeContext_ptr ctx)
    throw (CORBA::SystemException, Components::CCMException)
{
    context_ = Components::HomeContext::_duplicate(ctx);
}


::Components::EnterpriseComponent_ptr
ObserverHomeImpl::create ()
    throw (CORBA::SystemException, Components::CreateFailure)
{
// BEGIN USER INSERT SECTION ObserverHomeImpl::create
	cout << "ObserverHomeImpl: create() called" << endl;
// END USER INSERT SECTION ObserverHomeImpl::create
    return new ObserverImpl();
}


dinner::PhilosopherState*
ObserverHomeImpl::my_name()
	throw(CORBA::SystemException)
{
// BEGIN USER INSERT SECTION ObserverHomeImpl::my_name
	return 0;
// END USER INSERT SECTION ObserverHomeImpl::my_name
}


void
ObserverHomeImpl::muell(CORBA::Long l)
	throw(CORBA::SystemException)
{
// BEGIN USER INSERT SECTION ObserverHomeImpl::muell
// END USER INSERT SECTION ObserverHomeImpl::muell
}


::Components::EnterpriseComponent_ptr
ObserverHomeImpl::do_it(const char* name, dinner::PhilosopherState* state)
	throw(CORBA::SystemException, ::dinner::NotTheEater)
{
// BEGIN USER INSERT SECTION ObserverHomeImpl::do_it
	return 0;
// END USER INSERT SECTION ObserverHomeImpl::do_it
}


::Components::EnterpriseComponent_ptr
ObserverHomeImpl::find_it(const char* name)
	throw(CORBA::SystemException)
{
// BEGIN USER INSERT SECTION ObserverHomeImpl::find_it
	return 0;
// END USER INSERT SECTION ObserverHomeImpl::find_it
}


};


//
// entry point
//
::Components::HomeExecutorBase_ptr
create_ObserverHomeE(void)
{
// BEGIN USER INSERT SECTION create_ObserverHome
// END USER INSERT SECTION create_ObserverHome

    return new ::dinner::ObserverHomeImpl();
}

